import matplotlib.pyplot as plt
import student_code51
import random


plot_range_low = -20
plot_range_high= 20

xValues = []
yValuesf = []
yValuesF = []
xAxis = []

for x in range(plot_range_low,plot_range_high+1):
    xValues.append(x)
    yValuesf.append(student_code51.f(x))
    yValuesF.append(student_code51.F(x))
    xAxis.append(0)
    

a = random.randint(plot_range_low,plot_range_high-5)
b = random.randint(a+1,plot_range_high)

area = student_code51.calc_area(a,b)

print("The calculated area between a= " +str(a)+" and b= "+ str(b) +" is: " +str(area))



plt.plot(xValues,yValuesf,xValues,xAxis,'#000000')
plt.ylabel('f(x)')
plt.xlabel('x')
plt.title('Function f(x)')

ax = plt.gca()

valueRange = max(yValuesf) - min(yValuesf)

ax.axis([plot_range_low,plot_range_high,min(yValuesf)-0.15*valueRange,max(yValuesf)+0.15*valueRange])

ax.annotate("a",
            xy=(a,student_code51.f(a)), xycoords='data',
            xytext=(5, 30), textcoords='offset points',arrowprops=dict(facecolor='black', shrink=0.01)
            )

ax.annotate("b",
            xy=(b,student_code51.f(b)), xycoords='data',
            xytext=(5, 30), textcoords='offset points',arrowprops=dict(facecolor='black', shrink=0.01)
            )

ax.annotate("Area: "+"{:5.2f}".format(area),xy=(0,max(yValuesf)+0.05*valueRange), xycoords='data',xytext=(0, 0), ha="center", textcoords='offset points')


allowedArray =[]
for x in range(plot_range_low,plot_range_high+1):
    if x >=a and x <= b:
        allowedArray.append(True)
    else:
        allowedArray.append(False)

ax.fill_between(xValues, 0, yValuesf,where= allowedArray)

plt.show() 

plt.plot(xValues,yValuesF,xValues,xAxis,'#000000')
plt.ylabel('F(x)')
plt.xlabel('x')
plt.title('Antiderivative F(x)')

ax = plt.gca()

ax.annotate("a",
            xy=(a,student_code51.F(a)), xycoords='data',
            xytext=(5, 30), textcoords='offset points',arrowprops=dict(facecolor='black', shrink=0.01)
            )

ax.annotate("b",
            xy=(b,student_code51.F(b)), xycoords='data',
            xytext=(5, 30), textcoords='offset points',arrowprops=dict(facecolor='black', shrink=0.01)
            )

plt.show()   

